//alert('a3preloader');
(function() {
    // a3 preloader by gaoqingguang
    // version      1.0
    
    //----------------------------------
    
        var isTopFrame  = window == parent
        if (!isTopFrame) {
            return;
        }
        if (window._a3_preloadnext_inited) {
            return;
        }
        window._a3_preloadnext_inited = true;
        window._a3_preloadnext_supported = false; //是否支持.
        window._a3_preloadnext_state_loaded = false; //是否加载了拼接页面.
    
        var isAndroid = navigator.userAgent.indexOf('Android') > -1;
        var _rootDoc = window.document;
        var _ohtml = _rootDoc.documentElement;
        var main_url = document.location.href.replace(/#.*$/, ''); //url 去掉hash
        var domain_port = main_url.match(/https?:\/\/([^\/]+)/)[1]; //端口和域名,用来验证是否跨域.
    
        var _a3_preloadnext_config_builtin = [
            {
                host : 'm.qu.la'
            },
            {
                "host":"m.kukudm.com",
                "config" : {
                    "pageLimit" : 6
                }
            },
            // {
            //     host : 'm.manhuatai.com',
            //     config : {
            //         nextLink : 'css;.mh_footpager .mh_nextpage',
            //         clickNext : true //模拟点击导航到下一页.
            //     }
            // },
            {
                host : 'm.555zw.com',
                config : {
                    xhrLoad : false
                }
            },
            {
              host : 'wap.xxbiquge.com',
                config : {
                    xhrLoad : false
                }
            },
            {
                host : 'm.gifxiao.com',
                config : {
                    xhrLoad : false
                }
            }
        ];
    
        //console.dir(window.a3_preloadnext_config);
    
        // 全局变量:
        // oa._a3_pl_abs_href = ahref;  匹配的a对象， 设置属性_a3_pl_abs_href为自身的绝对url.
    
        var A3PlSiteInfo = {
            nextLink : null,  //
            startJs : null,
            clickNext : false,  //模拟点击导航到下一页.
            xhrLoad : false,  // 是否通过XMLHTTPRequest请求加载， 修改window.frames对象，避免页面被iframe导航走.
            pageLimit : 3,  //拼接的最大页数，超过后会删除最早拼接的页.
            heightLimit: 30000, //拼接页高度限制，
            regexpNew : false, //新方案正则检测下一页.
        };
    
        var autoMatch={
            pfwordl:{               //关键字前面的字符限定.
                previous:{          //上一页关键字前面的字符,例如 "上一页" 要匹配 "[上一页" ,那么prefix要的设置要不小于1,并且character要包含字符 "["
                    enable:true,
                    maxPrefix:3,
                    character:[' ','　','[','［','<','＜','‹','«','<<','『','「','【','(','←']
                },
                next:{//下一页关键字前面的字符
                    enable:true,
                    maxPrefix:2,
                    character:[' ','　','[','［','『','「','【','(']
                }
            },
            sfwordl:{               //关键字后面的字符限定.
                previous:{          //上一页关键字后面的字符
                    enable:true,
                    maxSubfix:2,
                    character:[' ','　',']','］','』','」','】',')']
                },
                next:{              //下一页关键字后面的字符
                    enable:true,
                    maxSubfix:3,
                    character:[' ','　',']','］','>','﹥','›','»','>>','』','」','】',')','→']
                }
            },
        };
    
        //下一页关键字
        var _a3_pl_next_page_keys;
        if (A3PlSiteInfo.regexpNew) {
            _a3_pl_next_page_keys = '下一页|下一頁|下1页|下1頁|下页|下頁|翻页|翻頁|翻下頁|翻下页|下一张|下一張|下一幅|下一章|下一节|下一節|下一篇|后一页|後一頁|前进|下篇|后页|往后|Next|Next Page|Next Section';
        } else {
            _a3_pl_next_page_keys=[
                '下一页', '下一頁', '下1页', '下1頁', '下页', '下頁',
                '翻页', '翻頁', '翻下頁', '翻下页',
                '下一张', '下一張', '下一幅', '下一章', '下一节', '下一節', '下一篇',
                '后一页', '後一頁',
                '前进', '下篇', '后页', '往后',
                'Next', 'Next Page', '次へ', '次のページ'
            ];
        }
        var _a3_pl_get_linktext_fn; //获取超链接文本的函数， 用于第二页及之后的寻找下一页.
    
    ///////////////////////////////////////////////////////////////////
        var debug = false ? console.log.bind(console) : function() {};
        if (typeof unsafeWindow == "undefined") {
            unsafeWindow = window;
        }
    
    // ====================  functions  ==============================
    
        // 是否进入了阅读模式, see: a3reader.js.
        function A3PL_hasEnterReadmode() {
            return window._a3_reader_state_showed || window._a3_reader_state_anima;
        }
    
        var A3CMD = (function(){
            var msgObj = {
                updateHistory : function(url, title){
                    var hisJson = JSON.stringify({url:url, title:title});
                    this.send('update_history:' + hisJson);
                },
                send : function(cmd) {
                    console.log('$a3preloadnext_cmd:' + cmd);
                },
            };
            return msgObj;
        })();
    
        function initConfig() {
            var _hostCheck = function(configHost, host) {
                do {
                    var off = host.indexOf('.');
                    if (off < 0) {
                        break;
                    }
    
                    if (configHost === host) {
                        return true;
                    }
                    host = host.substr(off+1);
                } while(host.length > 0);
                return false;
            }
            var _getConfig = function() {
                if (typeof(window.a3_preloadnext_config) == 'object') {
                    //alert('config=' + config);
                    return window.a3_preloadnext_config;
                }
                for (var i=0; i<_a3_preloadnext_config_builtin.length; i++) {
                    var item = _a3_preloadnext_config_builtin[i];
                    if (_hostCheck(item.host, document.domain)) {
                        return item;
                    }
                }
                return null;
            }
    
            var configItem = _getConfig();
            var config = configItem ? configItem.config : null;
            if (config) {
                if (typeof(config.nextLink) != 'undefined') {
                    A3PlSiteInfo.nextLink = config.nextLink;
                }
                if (typeof(config.clickNext) != 'undefined') {
                    A3PlSiteInfo.clickNext = config.clickNext;
                }
                if (typeof(config.xhrLoad) != 'undefined') {
                    A3PlSiteInfo.xhrLoad = config.xhrLoad;
                }
                if (typeof(config.pageLimit) != 'undefined') {
                    A3PlSiteInfo.pageLimit = config.pageLimit;
                }
            }
        }
    
        function A3PL_ForEachNode(nodeList, fn) {
            Array.prototype.forEach.call(nodeList, fn, this);
        }
    
        function A3PL_getElementTop(e) {
            var offset=e.offsetTop;
            if(e.offsetParent!=null) offset+=A3PL_getElementTop(e.offsetParent);
            return offset;
        }
    
        function parseKWRE() {
            function modifyPageKey(name, pageKey, pageKeyLength) {
                function strMTE(str) {
                    return (str.replace(/\\/g, '\\\\')
                        .replace(/\+/g, '\\+')
                        .replace(/\./g, '\\.')
                        .replace(/\?/g, '\\?')
                        .replace(/\{/g, '\\{')
                        .replace(/\}/g, '\\}')
                        .replace(/\[/g, '\\[')
                        .replace(/\]/g, '\\]')
                        .replace(/\^/g, '\\^')
                        .replace(/\$/g, '\\$')
                        .replace(/\*/g, '\\*')
                        .replace(/\(/g, '\\(')
                        .replace(/\)/g, '\\)')
                        .replace(/\|/g, '\\|')
                        .replace(/\//g, '\\/'));
                }
    
                var pfwordl = autoMatch.pfwordl,
                    sfwordl = autoMatch.sfwordl;
    
                var RE_enable_a = pfwordl[name].enable,
                    RE_maxPrefix = pfwordl[name].maxPrefix,
                    RE_character_a = pfwordl[name].character,
                    RE_enable_b = sfwordl[name].enable,
                    RE_maxSubfix = sfwordl[name].maxSubfix,
                    RE_character_b = sfwordl[name].character;
                var plwords,
                    slwords,
                    rep;
    
                plwords = RE_maxPrefix > 0 ? ('[' + (RE_enable_a ? strMTE(RE_character_a.join('')) : '.') + ']{0,' + RE_maxPrefix + '}') : '';
                plwords = '^\\s*' + plwords;
                slwords = RE_maxSubfix > 0 ? ('[' + (RE_enable_b ? strMTE(RE_character_b.join('')) : '.') + ']{0,' + RE_maxSubfix + '}') : '';
                slwords = slwords + '\\s*$';
                rep = 'i'; //不区分大小写.
    
                for (var i = 0; i < pageKeyLength; i++) {
                    pageKey[i] = new RegExp(plwords + strMTE(pageKey[i]) + slwords, rep);
                }
                return pageKey;
            }
    
            //转成正则.
            _a3_pl_next_page_keys = modifyPageKey('next', _a3_pl_next_page_keys, _a3_pl_next_page_keys.length);
        }
    
    // css 获取单个元素
        function getElementByCSS(css, contextNode) {
            return (contextNode || document).querySelector(css);
        }
    
    // xpath 获取单个元素
        function getElementByXpath(xpath, contextNode, doc) {
            doc = doc || document;
            contextNode = contextNode || doc;
            return doc.evaluate(xpath, contextNode, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null).singleNodeValue;
        }
    
    // 从相对路径的a.href获取完全的href值.
        function getFullHref(href) {
            if (typeof href != 'string') href = href.getAttribute('href');
    
            var a = getFullHref.a;
            if (!a) {
                getFullHref.a = a = document.createElement('a');
            }
            a.href = href;
            return a.href;
        }
    
        function getLinkText_Content(link) {
            return link.textContent;
        }
        function getLinkText_Title(link) {
            return link.title;
        }
        function getLinkText_Child(link) {
            var aimgs = link.getElementsByTagName('img');
            var j, jj;
            var atext;
            for (j = 0, jj = aimgs.length; j < jj; j++) {
                var aimg_x = aimgs[j];
                atext = aimg_x.alt || aimg_x.title;
                if (atext) break;
            }
            return atext;
        }
    
        function autoGetLink(doc) {
            var isMainFrame = doc == document;
            var curLHref = doc.location.href.replace(/#.*$/, '');
            var linkMap = new Map();
    
            function finalCheck(oa) {
                var ahref = oa.getAttribute('href'); //在chrome上当是非当前页面文档对象的时候直接用a.href访问,不返回href
                if (ahref == '#') {
                    return null;
                }
                ahref = getFullHref(ahref); //从相对路径获取完全的href;
    
                //3个条件:同域.
                if (/^https?:/i.test(ahref) && ahref.replace(/#.*$/, '') != curLHref && ahref.match(/https?:\/\/([^\/]+)/)[1] == domain_port) {
                    oa._a3_pl_abs_href = ahref;
                    return oa; //返回对象A
                }
                return null;
            }
    
            var idx;
            var alllinks = doc.links;
            for (idx=alllinks.length-1; idx>=0; idx--) {
                var oa = alllinks[idx];
                if (!oa) continue; //undefined跳过
                // 跳过无效链接
                if (!oa.offsetParent || oa.offsetWidth <= 0 || oa.offsetHeight <= 0 || (!oa.hasAttribute("href") && !oa.hasAttribute("onclick"))) {
                    continue;
                }
    
                var atext;
                var getLinkTextFn;
                if (_a3_pl_get_linktext_fn) {
                    atext = _a3_pl_get_linktext_fn(oa);
                } else {
                    atext = getLinkText_Content(oa);
                    getLinkTextFn = getLinkText_Content;
                    if (!atext) {
                        atext = getLinkText_Title(oa);
                        getLinkTextFn = getLinkText_Title;
                    }
                    if (!atext) {
                        atext = getLinkText_Child(oa);
                        getLinkTextFn = getLinkText_Child;
                    }
                }
                if (!atext || atext.length > 64) {
                    continue;
                }
                atext = atext.trim();
                if (atext.length <= 1) {
                    continue;
                }
    
                if (A3PlSiteInfo.regexpNew) {
                    var index = _a3_pl_next_page_keys.indexOf(atext);
                    if (index < 0) {
                        continue;
                    }
                    var nextlink = finalCheck(oa);
                    if (nextlink && nextlink._a3_pl_abs_href) {
                        nextlink._getLinkTextFn = getLinkTextFn;
                        nextlink._nextPageKey = atext;
                        nextlink._keyScore = _a3_pl_next_page_keys.length - index;
                        var firstlink = linkMap.get(nextlink._a3_pl_abs_href);
                        if (!firstlink || (A3PL_getElementTop(nextlink) > A3PL_getElementTop(firstlink))) {
                            linkMap.set(nextlink._a3_pl_abs_href, nextlink);
                        }
                    }
                } else {
                    for (var k = 0; k < _a3_pl_next_page_keys.length; k++) {
                        var keytext = _a3_pl_next_page_keys[k];
                        if (!(keytext.test(atext))) continue;
                        var nextlink = finalCheck(oa);
                        if (nextlink && nextlink._a3_pl_abs_href) {
                            nextlink._getLinkTextFn = getLinkTextFn;
                            nextlink._nextPageKey = keytext;
                            nextlink._keyScore = _a3_pl_next_page_keys.length - k;
                            var firstlink = linkMap.get(nextlink._a3_pl_abs_href);
                            if (!firstlink || (A3PL_getElementTop(nextlink) > A3PL_getElementTop(firstlink))) {
                                linkMap.set(nextlink._a3_pl_abs_href, nextlink);
                            }
                            break;
                        }
                    }
                }
    
                if (linkMap.size > 3) {
                    break;
                }
            }
    
            var destLink;
            linkMap.forEach(function(value, key, map) {
                if (!destLink) {
                    destLink = value;
                } else {
                    if (value._keyScore > destLink._keyScore) {
                        destLink = value;
                    }
                }
            });
            if (isMainFrame && destLink) {
                _a3_pl_get_linktext_fn = destLink._getLinkTextFn;
                if (A3PlSiteInfo.regexpNew) {
                    _a3_pl_next_page_keys = destLink._nextPageKey;
                } else {
                    _a3_pl_next_page_keys = [destLink._nextPageKey];
                }
            }
    
            return destLink;
        }

        var A3PLParser = (function() {
            var _nextLinkObject;
            var _nextLinkUrl;
            var _ownerPanel;
    
            // 获取单个元素,混合
            var _getElement = function(selector, doc, win) {
                var type = typeof selector;
                var ret;
                if (type == 'string') {
                    var contextNode = doc;
                    if (selector.search(/^css;/i) === 0) {
                        ret = getElementByCSS(selector.slice(4), contextNode);
                    } else {
                        ret = getElementByXpath(selector, contextNode, doc);
                    }
                } else if (type == 'function') {
                    ret = selector(doc, win);
                } else {
                    ret = autoGetLink(doc);
                }
                return ret;
            }
    
            var _parserDocument = function (doc, win, ownerPanel) {
                if (A3PlSiteInfo.startJs) {
                    A3PlSiteInfo.startJs(doc, win);
                }
    
                _nextLinkObject = _getElement(A3PlSiteInfo.nextLink, doc, win);
                if (_nextLinkObject) {
                    if (A3PlSiteInfo.clickNext) {
                        _nextLinkUrl = doc.URL;
                    } else {
                        _nextLinkUrl = getFullHref(_nextLinkObject);
                    }
                    _ownerPanel = ownerPanel;
                    var succeed = !!_nextLinkUrl;
                    if (!succeed) {
                        _nextLinkObject = undefined;
                    }
                }
    
                //  禁止iframe内部导航.
                if (doc != document) {
                    A3PL_ForEachNode(doc.links, function (oa) {
                      oa.target = '_parent';
                    });
                }
                return succeed;
            }
    
            return {
                init : function () {
                    initConfig();
                    if (!A3PlSiteInfo.regexpNew) {
                        parseKWRE();
                    }
                },
                parserDocument : function (doc, win, ownerPanel) {
                    return _parserDocument(doc, win, ownerPanel);
                },
                getNextLinkObject : function () {
                    return _nextLinkObject;
                },
                getNextLinkUrl : function () {
                    return _nextLinkUrl;
                },
                getNextLinkTop : function() {
                    if (_nextLinkObject) {
                        var top = A3PL_getElementTop(_nextLinkObject);
                        if (_ownerPanel) {
                            top += (A3PL_getElementTop(_ownerPanel) + _ownerPanel.clientHeight);
                        }
                        return top;
                    }
                    return -1;
                },
                reset : function () {
                    _nextLinkObject = _nextLinkUrl = _ownerFrame = null;
                }
            };
        })();
    
        //  begin exec:
        var onReady = function(cb) {
            if (document.readyState == 'loading') {
                var t = function() {
                    document.removeEventListener('DOMContentLoaded', t, false);
                    cb(document.readyState);
                }
                document.addEventListener('DOMContentLoaded', t, false)
            } else {
                cb(document.readyState);
            }
        }
        onReady(function(state) {
            var delayTime = 1500;
            setTimeout(function() {
                // 解决跟阅读模式的冲突.
                if (!A3PL_hasEnterReadmode() /* && A3PL_HasViewport() */) {
                    A3PLParser.init();
                    A3PLParser.parserDocument(document, window);
                    window._a3_preloadnext_supported = !!A3PLParser.getNextLinkObject();
                    if (window._a3_preloadnext_supported /* && _isTriggerLoad() */) {
                        // _preLoadNextPage();
                        A3CMD.send("A3Msg_Host_PreloadNext_Supported:" + A3PLParser.getNextLinkUrl());
                    }
                }
            }, delayTime);
        });
    })();
    
    //alert('preloader');
    
